#!/usr/bin/perl

# initial parameters
$limit=40; # the limit of bookmarks to display

# find bookmarks using spotlight
# Removed conditio Kind='Safari bookmark' because it is different in every language installation of Tiger
#$bookmarksString=`/usr/bin/mdfind "kMDItemKind='Safari bookmark' && kMDItemURL='feed*'"`;
$bookmarksString=`/usr/bin/mdfind "kMDItemURL='feed*'"`;
@bookmarkFiles=split(/\r?\n/, $bookmarksString);

# extract each bookmark's info
for($bmf=0;$bmf<@bookmarkFiles && $bmf<$limit;$bmf++){
	# generate the command to read files' metadata
	$command="/usr/bin/mdls -name kMDItemDisplayName -name kMDItemURL ".$bookmarkFiles[$bmf];
	# if this is not the last one, read the next one too
	if($bmf<@bookmarkFiles-1){ $command.=" ".$bookmarkFiles[$bmf+1]; }
	# if this is not the one before last one, read the next one too
	if($bmf<@bookmarkFiles-2){ $command.=" ".$bookmarkFiles[$bmf+2]; }
	# if this is not the one before the one before last one, read the next one too
	if($bmf<@bookmarkFiles-3){ $command.=" ".$bookmarkFiles[$bmf+3]; }
	$command.=" |";
	open(IN, $command);

	# process each line
	while($line=<IN>){
		# extract name
		if($line =~ /kMDItemDisplayName\s*=\s*"(.*)"/){
			$bookmarks[$bmf] = $1;
		}
		# extract url
		if($line =~ /kMDItemURL\s*=\s*"(.*)"/){
			$bookmarks[$bmf] .= "|=|".$1;
			$bookmarks[$bmf] =~ s/feed:\/\//http:\/\//;
			$bmf++;
		}
	}
	$bmf--;
	close IN;
}

# sort results
@bookmarks = sort {lc $a cmp lc $b} @bookmarks;

# print the total of bookmarks found
print (@bookmarkFiles*1);
print "\n";
# print results
for($f=0;$f<@bookmarks;$f++){
	print $bookmarks[$f]."\n";
}
